// Layer dragging code and DOM detection courtesy of http://www.unitedscripters.com

//Global Variables
var mapHeight = "";
var mapWidth = ""; 
var currentParent = "";
var currentChild = "";
var currentCounter = "";
var layerCount = 0;
var concernedLayers = new Array();
var engagedZindex = 0;
var engaged = null;
var sSDWindowCount = 0;

//DOM detected build up:
if (document.getElementById) {
	obj1 = "document.getElementById('";
	obj2 = "')";
	style = ".style";
	eX = (navigator.appName.indexOf("Internet Explorer") == -1) ?  "e.clientX" : "event.clientX";
	eY = (navigator.appName.indexOf("Internet Explorer") == -1) ? "e.clientY" : "event.clientY";
	offsetX = (navigator.appName.indexOf("Internet Explorer") == -1) ? "pageXOffset" : "document.body.scrollLeft";
	offsetY = (navigator.appName.indexOf("Internet Explorer") == -1) ? "pageYOffset" : "document.body.scrollTop";
}
else if (document.all) {
	obj1 = "document.all['";
	obj2 = "']";
	style = ".style";
	eX = "event.clientX";
	eY = "event.clientY";
	offsetX = "document.body.scrollLeft";
	offsetY = "document.body.scrollTop";
}
else if (document.layers) {
	obj1 = "document.layers['";
	obj2 = "']";
	style = "";
	eX = "e.pageX";
	eY = "e.pageY";
	offsetX = "pageXOffset";
	offsetY = "pageYOffset";
	document.captureEvents(Event.MOUSEDOWN | Event.MOUSEMOVE | Event.MOUSEUP);
}
//DOM build up now over


function initializeLayers() {  

	// Set the event handlers for dragging the layers
	document.onmousedown = events;
	document.onmousemove = dragLayer;
	document.onmouseup = disengage;
	//document.onclick = closeWindows;

	// Set the map height and width to avoid placing layers outside the bounds of the map
    mapHeight = document.images["map"].clientHeight; 
	mapWidth = document.images["map"].clientWidth;	
	
	//Get a collection of all the <SPAN> elements on the map
	oHexes = document.getElementsByTagName("SPAN"); 

	//alert(oHexes.length);	
	for (i=0; i < oHexes.length; i++) {
		hexName = eval(oHexes[i]);	

		//Ignore SPANs that don't have an ID	
		if (hexName.id != "") {
			oCounters = oHexes[i].getElementsByTagName("IMG");	
			// If we have more than one counter, we'll have child layers
			// Otherwise we'll only have the parent
			if (oCounters.length <= 1)
				oCounters = "";
	
			positionLayers(hexName, oCounters);
		}
	}
}

function positionLayers(hexName, oCounters) {
 
	//Get the position and size information of the parent span
	//This is used to position the parent and child layers 	
	hexTop = parseInt(hexName.style.top);
	hexLeft = parseInt(hexName.style.left);
	hexHeight = parseInt(hexName.style.height);
	hexWidth = parseInt(hexName.style.width);

	//Use getElementById to verify we have a valid layer to use
	parentLayer = document.getElementById(hexName.id.replace("spn", "hex"));
	
	//If the parent layer does not exist, exit the function
    if(parentLayer == null)
		return;
	
	//Get the parent layer's dimensions
	parentLayerHeight = parentLayer.clientHeight;
	parentLayerWidth = parentLayer.clientWidth;
	
	//default position is parent layer above span, parent layer right edge aligned with span right edge
	parentLayer.style.top = hexTop - parentLayerHeight;
	parentLayer.style.left = hexLeft + hexWidth - parentLayerWidth;
	
	// Too close to top	  
	if (parseInt(parentLayer.style.top) < 0) {
		parentLayer.style.top = 0;
		parentLayer.style.left = hexLeft - parentLayerWidth;
	}	
		
	// Too close to left
	if (parseInt(parentLayer.style.left) < 0)
		parentLayer.style.left = 0;
		
	// Add the parent to the array of layers (used for dragging)
	concernedLayers[layerCount] = new Array(parentLayer.id, parentLayer.clientWidth, parentLayer.clientHeight);
	layerCount++;
	
	// Process the child layers, if any	
	for (j = 0; j < oCounters.length; j++) {
		childLayer = document.getElementById(oCounters[j].id.substring(3, oCounters[j].id.length));
		
		if(childLayer != null) {
			childLayerHeight = childLayer.clientHeight;
			childLayerWidth = childLayer.clientWidth;
		
			//default position is to the right of parent, bottom-aligned, space permitting
			childLayer.style.top = parseInt(parentLayer.style.top);
			childLayer.style.left = parseInt(parentLayer.style.left) + parentLayerWidth + 5;

			//move down if too close to map top
			if (parseInt(childLayer.style.top) < 0)
				childLayer.style.top = 0;
		
			//move to left of parent if too close to right map edge
			if (parseInt(childLayer.style.left) + childLayerWidth > mapWidth) {
					childLayer.style.left = parseInt(parentLayer.style.left) - childLayerWidth - 5;		
			}	
				
			// Add the child layer to the array (for dragging)
			concernedLayers[layerCount] = new Array(childLayer.id, childLayer.clientWidth, childLayer.clientHeight);
			layerCount++;
		}
	}
}

function showParent(parentName) {

	//Open the desired layer
	newLayer = document.getElementById(parentName);
	
	if (newLayer != null) {
		if (currentParent != parentName) {
			if (currentParent != "") {
				// Close the previous layer
				oldParent = document.getElementById(currentParent);
				oldChild = document.getElementById(currentChild);
				oldParent.style.visibility = "hidden";
				if (oldChild != null) {
					oldChild.style.visibility = "hidden";
					currentChild = "";
				}
				currentParent = "";
			}
			newLayer.style.visibility = "visible";
			currentParent = parentName;
		}
	}
}

function closeParent(layerName) {

	layerToClose = document.getElementById(layerName);
	
	if (layerToClose != null) {
		if (currentChild != "") {
			// We have a child that needs to be closed
			oldChild = document.getElementById(currentChild);
			oldChild.style.visibility = "hidden";
			currentChild = "";
		}
		layerToClose.style.visibility = "hidden";
		currentParent = "";
	}
}

function showChild(childName) {

	newLayer = document.getElementById(childName);
	newCounter = document.getElementById("img" + childName);
		
	if (newLayer != null) {
		if (currentChild != childName) {
			if (currentChild != "") {
				// Close the previous layer
				oldChild = document.getElementById(currentChild);
				oldCounter = document.getElementById(currentCounter);
				oldChild.style.visibility = "hidden";
				oldCounter.style.zIndex = 2;
				currentChild = "";
				currentCounter = "";
			}
			newLayer.style.visibility = "visible";
			currentChild = childName;
			newCounter.style.zIndex = 3;
			currentCounter = "img" + childName;
		}
	}
}

function closeChild(childName) {

	newLayer = document.getElementById(childName);
	newCounter = document.getElementById("img" + childName);
	
	if (newLayer != null) {
		newLayer.style.visibility = "hidden";
		currentChild = "";
		newCounter.style.zIndex = "2";
		currentCounter = "";
	}
}

function showParentChild(parentName, childName) {

	showParent(parentName);
	showChild(childName);


}

function closeWindows() {

	//alert("closeWindows!");

	
	if (currentParent != "") {
		closeParent(currentParent);
	}
}

function displaySSD(unitName) {

//	var ssdSRC = unitName+".gif"	
	
	sSDWindowCount++
	var wName = "ssd"+parseInt(sSDWindowCount)
	
	mapWindow = window.open("", wName, "toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,copyhistory=no, width = 950, height = 750")
	mapWindow.document.write('<img border="0" name="ship" src="'+unitName+'.gif">')
	mapWindow.document.close();
	document.close();
	
	
}

function events(e) {//argument must be set as e 

	var Xin = eval(eX);
	var Yin = eval(eY);
	/*thanks to Dynamic HTML by Danny Goodman for
	settings of following looping idea*/
	for (var i = 0; i < concernedLayers.length; i++) {
		var OGG = eval(obj1 + concernedLayers[i][0] + obj2 + style);
		//is it visible?:
		var visib = OGG.visibility;
		if (visib == "hidden" || visib == "hide") {
			continue;
		}
		var layerW = concernedLayers[i][1];
		var layerH = concernedLayers[i][2];
		var L = parseFloat(OGG.left); //parseFloat: could carry a trailing "px" !
		var T = parseFloat(OGG.top);
		var offX = (document.layers) ? 0 : eval(offsetX); //in case you scrolled
		var offY = (document.layers) ? 0 : eval(offsetY);
		if (Xin > (L - offX) && Xin < (L - offX + layerW) && Yin > (T - offY) && Yin < (T - offY + layerH)){
			engaged = i;
			moveX = Xin - L;
			moveY = Yin - T;
			engagedZindex = OGG.zIndex;
			setIndex(concernedLayers[i][0]);
			return;
		}
	}
	engaged = null;
/*keep this comment to reuse freely
http://www.unitedscripters.com */
}

function setIndex(theLayer, how) {

	var OGG = eval(obj1 + theLayer + obj2 + style);
	OGG.zIndex = (how) ? how : 101;
}

function disengage() {

	if (engaged == null) {
		return false;
	}
	setIndex(concernedLayers[engaged][0], engagedZindex);
	moveX = null;
	moveY = null;
	engaged = null;
}

function dragLayer(e) {

	if (engaged == null) {
		return false;
	}
	var Xin = eval(eX);
	var Yin = eval(eY);
	var OGG = eval(obj1 + concernedLayers[engaged][0] + obj2 + style);
	//now move it
	OGG.top =Yin - moveY;
	OGG.left = Xin - moveX;
/*keep this comment to reuse freely
http://www.unitedscripters.com */
}


